Skip to main content
A newer version of this page is available. .

Document Viewer Integration in Angular2

  • 4 minutes to read

You can use the HTML5 Document Viewer in JavaScript with Angular by creating two projects: a server (backend) project in ASP.NET MVC implementation and a client (frontend) part that includes all the necessary styles, scripts, and HTML-templates.

Note

Perform steps in the Creating a Server Side for the Web Document Viewer topic to create a backend application.

This document describes how to create and configure the client part:

  1. Install Node.js and npm if they do not exist on your machine.
  2. Open the console window and install the Angular CLI (command line interface tool) globally.

    npm install -g \@angular/cli

  3. Create a new folder to store all the files related to the client-side functionality.
  4. Navigate to the added folder and run the following command in the console to create a new project:

    ng new angular-example

    Refer to the Angular documentation for information on the application’s structure and created files’ purposes.

  5. In the console, use the following commands to change your current directory to the created project’s folder and add the webpack.config.js file:

    cd angular-example ng eject

  6. Open the package.json configuration file and list the following third-party packages the Web Document Viewer requires:

    ...
      "dependencies": {
        ...
        "devexpress-reporting": "~17.2.5",
        "devextreme": "~17.2.5",
        "globalize":"~1.3.0",
        "cldrjs":"~0.5.0",
        "knockout":"~3.4.2",
        "jquery":"~3.1.1",
        "jquery-ui":"~1.12.1"
      },
    ...
    

    Refer to Document Viewer Requirements and Limitations for a list of the necessary client resources for deploying the control.

  7. Switch back to the console and run the command below to install packages:

    npm install

    After installation is completed, you can find all the libraries in the node_modules folder.

  8. Open the webpack.config.js file and add the following code to the module.exports object to create aliases for certain modules:

    module.exports = {
      "resolve": {
        ...
        "alias": {
          globalize$: path.resolve(__dirname, "node_modules/globalize/dist/globalize.js"),
          globalize: path.resolve(__dirname, "node_modules/globalize/dist/globalize"),
          cldr$: path.resolve(__dirname, "node_modules/cldrjs/dist/cldr.js"),
          cldr: path.resolve(__dirname, "node_modules/cldrjs/dist/cldr"),
          ...
        },
     },
    

    Use the code below instead if the alias option is specified in the created project using the rxPaths function. Declare a variable with required paths prior to the module.exports object and then assign this variable to the alias option.

    const alias = rxPaths();
    alias["globalize$"] = path.resolve(__dirname, "node_modules/globalize/dist/globalize.js");
    alias["globalize"] = path.resolve(__dirname, "node_modules/globalize/dist/globalize");
    alias["cldr$"] = path.resolve(__dirname, "node_modules/cldrjs/dist/cldr.js");
    alias["cldr"] = path.resolve(__dirname, "node_modules/cldrjs/dist/cldr");
    
    module.exports = {
      "resolve": {
           ...
           "alias": alias
        },
      "resolveLoader": {
           ...
           "alias": alias
        },
    };
    
  9. In the console window, generate a new report-viewer Angular component.

    ng generate component report-viewer

  10. Open the report-viewer.component.html file and specify the HTML template using the dxReportViewer binding.

    <div #scripts></div>
    <div #control style="width:100%; height: 1000px">
      <div data-bind="dxReportViewer: $data"></div>
    </div>
    
  11. In the report-viewer.component.ts file, import the required decorators and modules and write the component for the Web Document Viewer as demonstrated below. Create the required parameters and activate the Knockout bindings.

    import { Component, ViewChild, AfterViewInit, Renderer2, Input, ElementRef } from '@angular/core';
    import * as ko from "knockout";
    import { Html } from "devexpress-reporting/dx-web-document-viewer";
    
    @Component({
      selector: 'report-viewer',
      templateUrl: './report-viewer.component.html',
      styleUrls: ['./report-viewer.component.css']
    })
    export class ReportViewerComponent implements AfterViewInit {
    
      koReportUrl = ko.observable(null);
      _reportUrl;
    
      @ViewChild('scripts')
      scripts: ElementRef;
    
      @ViewChild("control")
      control: ElementRef
    
      constructor(private renderer: Renderer2) { }
    
      ngAfterViewInit() {
        const reportUrl = this.koReportUrl,
          host = 'http://localhost:54114/',
          container = this.renderer.createElement("div");
        container.innerHTML = Html;
        this.renderer.appendChild(this.scripts.nativeElement, container);
        ko.applyBindings({
          reportUrl, // The URL of a report that is opened in the Document Viewer when the application starts. 
          requestOptions: { // Options for processing requests from the Web Document Viewer. 
            host, // URI of your backend project. 
            invokeAction: "/WebDocumentViewer/Invoke" // The URI path of the controller action that processes requests. 
          }
        }, this.control.nativeElement);
      }
    
      @Input()
      set reportUrl(reportUrl: string) {
        this._reportUrl = reportUrl;
        this.koReportUrl(reportUrl);
      }
      get reportUrl() {
        return this._reportUrl;
      }
    }
    
  12. Open the app.component.html file and specify the root component’s HTML template.

    <div style="width:100%; height:100%">
      <report-viewer [reportUrl]="reportUrl"></report-viewer>
    </div>
    
  13. In the app.component.ts file, modify the root component as follows:

    export class AppComponent {
      title = 'app';
      reportUrl = "Products";
    }
    
  14. Link global styles for your application in the style.css file.

    @import url("../node_modules/jquery-ui/themes/base/all.css");
    @import url("../node_modules/devextreme/dist/css/dx.common.css");
    @import url("../node_modules/devextreme/dist/css/dx.light.css");
    @import url("../node_modules/devexpress-reporting/css/web-document-viewer-light.min.css");
    
  15. For the example to work correctly, you should first run a backend project in Visual Studio, and then, run the client part.

    Use the command below to launch the server and rebuild the application each time you make changes to the source files:

    npm start

    Open your browser on http://localhost:4200/ to see the result.

See Also

Skip to main content
A newer version of this page is available. .

Document Viewer Integration in ReactJS

  • 3 minutes to read

You can use the HTML5 Document Viewer in JavaScript with React by creating two projects: a server (backend) project in ASP.NET MVC implementation, and a client (frontend) part that includes all the necessary styles, scripts, and HTML-templates.

Note

See the Creating a Server Side for the Web Document Viewer topic for details on how to create a backend application.

This document describes how to configure and host the client part:

  1. Create a new folder to store all the files related to the client-side functionality (for instance, name it ClientSide).
  2. Download all the necessary client resources using Bower. Add the bower.json file in the created folder and add the following code to this file:

    {
      "name": "html5-document-viewer-example-react",
      "dependencies": {
        "xtrareportsjs": "~17.2.3",
        "react": "latest",
        "babel": "latest"
      }
    }
    

    Ensure that you correctly specify the required reporting controls’ version.

  3. Open the console, navigate to your application folder and run the following command:

    bower install

    After installation is completed, you can find all the libraries in the bower_components folder.

  4. Create a View file in the root folder (the index.html file in this example) and add links to Bower resources to the head section.

    <head>
        <title></title>
        <link rel="stylesheet" href="bower_components/devextreme/css/dx.common.css" />
        <link rel="stylesheet" href="bower_components/devextreme/css/dx.light.css" />
        <script type="text/javascript" src="bower_components/jquery/dist/jquery.js"></script>
        <script type="text/javascript" src="bower_components/knockout/dist/knockout.js"></script>
        <script type="text/javascript" src="bower_components/devextreme/js/dx.all.js"></script>
        <script type="text/javascript" src="bower_components/jquery-ui/jquery-ui.js"></script>
        <link href="bower_components/jquery-ui/themes/base/jquery-ui.min.css" rel="stylesheet" />
    
        <link href="bower_components/xtrareportsjs/css/web-document-viewer-light.css" rel="stylesheet" />
        <script type="text/html" src="bower_components/xtrareportsjs/html/web-document-viewer.html"></script>
        <script type="text/javascript" src="bower_components/xtrareportsjs/js/dx-designer.js"></script>
        <script type="text/javascript" src="bower_components/xtrareportsjs/js/web-document-viewer.js"></script>
        <script type="text/javascript" src="bower_components/xtrareportsjs/js/localization/web-document-viewer.en.js"></script>
    
        <script type="text/javascript" src="bower_components/react/react.development.js"></script>
        <script type="text/javascript" src="bower_components/react/react-dom.development.js"></script>
        <script type="text/javascript" src="bower_components/babel/browser.js"></script>
    </head>
    

    Make sure that you meet all the requirements for deploying the control on the client. Refer to Document Viewer Requirements and Limitations for a complete client resource list.

    Note that this sample uses a script with a predefined localization dictionary.

  5. Add a JSX file (example.jsx) to provide the required data to the View.

    Create the ReportViewer and Root classes that extend the base React.Component class as shown below. Use the dxReportViewer binding to render the Document Viewer element.

    "use strict"
    const host = 'http://localhost:54114/';
    
    class ReportViewer extends React.Component {
        constructor(props) {
            super(props);
            this.reportUrl = ko.observable(props.reportUrl);
            this.requestOptions = {
                host,
                invokeAction: "WebDocumentViewer/Invoke"
            };
        }
        render() {
            return (<div ref="viewer" data-bind="dxReportViewer: $data"></div>);
        }
        componentWillReceiveProps(newProps) {
            this.reportUrl(newProps.reportUrl);
        }
        componentDidMount() {
            ko.applyBindings({
                reportUrl: this.reportUrl,
                requestOptions: this.requestOptions
            }, this.refs.viewer);
        }
        componentWillUnmount() {
            ko.cleanNode(this.refs.viewer);
        }
    }
    
    class Root extends React.Component {
        constructor(props) {
            super(props);
            this.state = { value: "Products", reports: [] };
        }
    
        render() {
            return (<div style = {{width: "100%", height: "1000px"}}>
                <ReportViewer reportUrl={this.state.value} />
            </div>);
        }
    }
    
    ReactDOM.render(<Root />, document.getElementById("viewerhost"))
    
  6. Link the file created at the previous step in the index.html file:

    ...
    
    <body>
        <div id="viewerhost"></div>
        <script type="text/babel" src="example.jsx"></script>
    </body>
    
  7. Host your client-side part on the web server.

    For instance, start the Internet Information Services (IIS) Manager, right-click the Sites item in the Connections section and select Add Website. In the invoked dialog, specify the site name, the path to the folder with the client-side functionality and the website’s IP address.

    host-react-example-in-iis

  8. For this example to work correctly, you should first run a backend project in Visual Studio before running the client part.
See Also